# General-purpose Photovoltaic Device Model gpvdm.com - a drift diffusion
# base/Shockley-Read-Hall model for 1st, 2nd and 3rd generation solarcells.
# The model can simulate OLEDs, Perovskite cells, and OFETs.
# 
# Copyright (C) 2008-2020 Roderick C. I. MacKenzie
# All rights reserved.
# 
# https://www.gpvdm.com
# r.c.i.mackenzie at googlemail.com
# 
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in the
#       documentation and/or other materials provided with the distribution.
#     * Neither the name of the GPVDM nor the
#       names of its contributors may be used to endorse or promote products
#       derived from this software without specific prior written permission.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL Roderick C. I. MacKenzie BE LIABLE FOR ANY
# DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.


import os
from icon_lib import QIcon_load

from tb_item_sim_mode import tb_item_sim_mode
from tb_item_sun import tb_item_sun

from code_ctrl import enable_betafeatures
from cal_path import get_css_path

#qt
from PyQt5.QtWidgets import QMainWindow, QTextEdit, QAction, QApplication
from PyQt5.QtGui import QIcon,QCursor
from PyQt5.QtCore import QSize, Qt,QFile,QIODevice,QEvent
from PyQt5.QtWidgets import QWidget,QSizePolicy,QVBoxLayout,QHBoxLayout,QPushButton,QDialog,QFileDialog,QToolBar,QMessageBox, QLineEdit, QToolButton
from PyQt5.QtWidgets import QTabWidget


class cool_menu(QToolBar):

	def __init__(self,parent):
		QToolBar.__init__(self)

		#aaa=self.readStyleSheet(os.path.join(get_css_path(),"menu.css"))
		#aaa=str(aaa,'utf-8')
		#self.setStyleSheet(aaa)

		self.setToolButtonStyle( Qt.ToolButtonTextBesideIcon)
		self.setOrientation(Qt.Vertical)
		#self.setWindowFlags(Qt.FramelessWindowHint|Qt.WindowStaysOnTopHint|Qt.WindowStaysOnTopHint)
		self.setIconSize(QSize(42, 42))

		self.configure_configwindow = QAction(QIcon_load("help"), _("Help window"), self)
		self.addAction(self.configure_configwindow)

		self.configure_configwindow = QAction(QIcon_load("help"), _("Manual"), self)
		self.addAction(self.configure_configwindow)

		self.configure_configwindow = QAction(QIcon_load("help"), _("License"), self)
		self.addAction(self.configure_configwindow)

		self.configure_configwindow = QAction(QIcon_load("help"), _("Youtube"), self)
		self.addAction(self.configure_configwindow)

		self.configure_configwindow = QAction(QIcon_load("help"), _("Citing the model"), self)
		self.addAction(self.configure_configwindow)

		self.configure_configwindow = QAction(QIcon_load("help"), _("About"), self)
		self.addAction(self.configure_configwindow)

		l=self.layout()
		for i in range(0,l.count()):
			l.itemAt(i).setAlignment(Qt.AlignLeft)


		self.installEventFilter(self)
		self.setWindowFlags(Qt.Popup)

		self.move(self.mapFromGlobal(QCursor.pos()))

	def eventFilter(self, object, event):
		if event.type()== QEvent.WindowDeactivate:
			self.setVisible(False)

		return False

	def readStyleSheet(self,fileName):
		file = QFile(fileName)
		if file.open(QIODevice.ReadOnly) :
			css = file.readAll()
			file.close()
		return css

