# General-purpose Photovoltaic Device Model gpvdm.com - a drift diffusion
# base/Shockley-Read-Hall model for 1st, 2nd and 3rd generation solarcells.
# The model can simulate OLEDs, Perovskite cells, and OFETs.
# 
# Copyright (C) 2008-2020 Roderick C. I. MacKenzie
# All rights reserved.
# 
# https://www.gpvdm.com
# r.c.i.mackenzie at googlemail.com
# 
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in the
#       documentation and/or other materials provided with the distribution.
#     * Neither the name of the GPVDM nor the
#       names of its contributors may be used to endorse or promote products
#       derived from this software without specific prior written permission.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL Roderick C. I. MacKenzie BE LIABLE FOR ANY
# DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.


import os
import shutil

class dat_file():
	valid_data=False
	grid=False
	show_pointer=False
	logy=False
	logx=False
	logz=False
	logdata=False
	label_data=False
	invert_y=False
	normalize=False
	norm_to_peak_of_all_data=False
	subtract_first_point=False
	add_min=False
	legend_pos="lower right"
	ymax=-1
	ymin=-1
	x_label=""
	y_label=""
	z_label=""
	data_label=""
	x_units=""
	y_units=""
	z_units=""
	data_units=""
	x_mul=1.0
	y_mul=1.0
	z_mul=1.0
	data_mul=1.0
	key_units=""
	file0=""
	tag0=""
	file1=""
	tag1=""
	file2=""
	tag2=""
	example_file0=""
	example_file1=""
	example_file2=""
	time=0.0
	Vexternal=0.0
	file_name=""
	other_file=""
	title=""
	type="xy"
	section_one=""
	section_two=""

	x_start=0
	x_stop=1
	x_points=25
	y_start=0
	y_stop=1
	y_points=25
	x_len=0
	y_len=0
	z_len=0

	x_scale=[]
	y_scale=[]
	z_scale=[]
	data=[]
	labels=[]
