# General-purpose Photovoltaic Device Model gpvdm.com - a drift diffusion
# base/Shockley-Read-Hall model for 1st, 2nd and 3rd generation solarcells.
# The model can simulate OLEDs, Perovskite cells, and OFETs.
# 
# Copyright (C) 2008-2020 Roderick C. I. MacKenzie
# All rights reserved.
# 
# https://www.gpvdm.com
# r.c.i.mackenzie at googlemail.com
# 
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in the
#       documentation and/or other materials provided with the distribution.
#     * Neither the name of the GPVDM nor the
#       names of its contributors may be used to endorse or promote products
#       derived from this software without specific prior written permission.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL Roderick C. I. MacKenzie BE LIABLE FOR ANY
# DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.


import os

#qt
from PyQt5.QtCore import QSize, Qt
from PyQt5.QtWidgets import QWidget,QLineEdit,QComboBox,QHBoxLayout,QPushButton,QLabel,QDialog,QVBoxLayout,QToolBar,QSizePolicy,QAction,QTabWidget,QTableWidget,QAbstractItemView, QMenuBar,QApplication
from PyQt5.QtGui import QPainter,QIcon,QImage

from PyQt5.QtCore import QSize, Qt

class dlg_get_multi_text(QDialog):

#	def callback_edit2(self):
#		self.populate_combo_box_using_input_file(self.token2,self.file2.text())

	def callback_click_ok(self):
		self.ret=[]
		for box in self.edit_boxes:
			self.ret.append(box.text())

		self.close()

	def callback_click_cancel(self):
		self.close()

	def __init__(self,info,title="gpvdm"):
		QWidget.__init__(self)
		self.ret=False
		self.setWindowTitle(title)
		self.setWindowFlags(Qt.WindowStaysOnTopHint)
		self.vbox=QVBoxLayout()
		self.edit_boxes=[]
		for i in range(0,len(info)):
			l=QLabel(info[i][0])
			self.vbox.addWidget(l)

			self.edit_boxes.append(QLineEdit())
			self.edit_boxes[-1].setText(info[i][1])

			self.vbox.addWidget(self.edit_boxes[-1])


		w=QWidget()
		hb=QHBoxLayout()
		w.setLayout(hb)
		ok=QPushButton(_("OK"))
		ok.pressed.connect(self.callback_click_ok)
		cancel=QPushButton(_("Cancel"))
		cancel.pressed.connect(self.callback_click_cancel)

		hb.addWidget(cancel)
		hb.addWidget(ok)

		self.vbox.addWidget(w)

		self.setLayout(self.vbox)

	def get_values(self):
		return self.ret

	def run(self):
		self.exec_()


