# General-purpose Photovoltaic Device Model gpvdm.com - a drift diffusion
# base/Shockley-Read-Hall model for 1st, 2nd and 3rd generation solarcells.
# The model can simulate OLEDs, Perovskite cells, and OFETs.
# 
# Copyright (C) 2008-2020 Roderick C. I. MacKenzie
# All rights reserved.
# 
# https://www.gpvdm.com
# r.c.i.mackenzie at googlemail.com
# 
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in the
#       documentation and/or other materials provided with the distribution.
#     * Neither the name of the GPVDM nor the
#       names of its contributors may be used to endorse or promote products
#       derived from this software without specific prior written permission.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL Roderick C. I. MacKenzie BE LIABLE FOR ANY
# DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.


import sys
from OpenGL.GL import *

class color():
	def __init__(self,r,g,b,alpha):
		self.r=r
		self.g=g
		self.b=b
		self.alpha=alpha
		self.name=""

color_list=[]
false_color=False

def search_color(r,g,b):
	global color_list
	n=0
	my_min=1000.0
	for i in range(0,len(color_list)):
		val=abs(color_list[i].r-r)+abs(color_list[i].g-g)+abs(color_list[i].b-b)
		if val<my_min:
			my_min=val
			n=i
	return color_list[n].name

def set_false_color(value):
	global false_color
	false_color=value

def set_color(r,g,b,name,alpha=-1):
	global color_list
	global false_color
	if false_color==True:
		rgb_int=len(color_list)
		r =  rgb_int & 255
		g = (rgb_int >> 8) & 255
		b =   (rgb_int >> 16) & 255
		r=r/255
		g=g/255
		b=b/255

	a=color(r,g,b,alpha)
	a.name=name
	color_list.append(a)
	glColor3f(r,g,b)

def clear_color():
	global color_list
	color_list=[]

def set_color_alpha(r,g,b,alpha,name):
	global color_list
	a=color(r,g,b,alpha)
	a.name=name
	color_list.append(a)
	glColor4f(r,g,b, alpha)

def print_color():
	global color_list
	for i in range(0,len(color_list)):
		print(color_list[i].r,color_list[i].g,color_list[i].b,color_list[i].alpha,color_list[i].name)

