# General-purpose Photovoltaic Device Model gpvdm.com - a drift diffusion
# base/Shockley-Read-Hall model for 1st, 2nd and 3rd generation solarcells.
# The model can simulate OLEDs, Perovskite cells, and OFETs.
# 
# Copyright (C) 2008-2020 Roderick C. I. MacKenzie
# All rights reserved.
# 
# https://www.gpvdm.com
# r.c.i.mackenzie at googlemail.com
# 
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in the
#       documentation and/or other materials provided with the distribution.
#     * Neither the name of the GPVDM nor the
#       names of its contributors may be used to endorse or promote products
#       derived from this software without specific prior written permission.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL Roderick C. I. MacKenzie BE LIABLE FOR ANY
# DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.


import sys
import glob
class save_object():
	def __init__(self):
		id=""
		x=0.0
		y=0.0
		z=0.0
		vec=[]

save_list=[]

def gl_save_clear():
	global save_list
	save_list=[]

def gl_save_add(string,x,y,z,vector):
	a=save_object()
	a.x=x
	a.y=y
	a.z=z
	a.id=string
	a.vec=' '.join(map(str, vector))
	save_list.append(a)

def gl_save_print():
	global save_list
	print(save_list)

def gl_save_list():
	global save_list
	return save_list

def gl_save_save(file_name):
	global save_list
	text_file = open(file_name, "w")
	for item in save_list:
		text_file.write(item.id+" "+str(item.x)+" "+str(item.y)+" "+str(item.z)+" "+item.vec+"\n")
	text_file.close()

def gl_save_load():
	global save_list
	save_list=[]
	mul=4.0
	files=glob.glob("*.3d")
	start=mul*len(files)
	for i in range(0,len(files)):
		dx=i*mul-start
		f = open(files[i], "r")
		lines = f.readlines()
		f.close()
		for line in lines:
			split=line.split()
			v=[]
			for ii in range(4,len(split)):
				v.append(float(split[ii]))
			gl_save_add(split[0],float(split[1])+dx,float(split[2]),float(split[3]),v)


