# General-purpose Photovoltaic Device Model gpvdm.com - a drift diffusion
# base/Shockley-Read-Hall model for 1st, 2nd and 3rd generation solarcells.
# The model can simulate OLEDs, Perovskite cells, and OFETs.
# 
# Copyright (C) 2008-2020 Roderick C. I. MacKenzie
# All rights reserved.
# 
# https://www.gpvdm.com
# r.c.i.mackenzie at googlemail.com
# 
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in the
#       documentation and/or other materials provided with the distribution.
#     * Neither the name of the GPVDM nor the
#       names of its contributors may be used to endorse or promote products
#       derived from this software without specific prior written permission.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL Roderick C. I. MacKenzie BE LIABLE FOR ANY
# DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.


#import os

import i18n
_ = i18n.language.gettext


class descriptor():
	def __init__(self,file,des):
		self.file=file
		self.des=des

inp_files=[]
inp_files.append(descriptor("device.inp",_("Device")))
inp_files.append(descriptor("jv.inp",_("JV")))
inp_files.append(descriptor("diode_equ.inp",_("JV Simple")))
inp_files.append(descriptor("dump.inp",_("Dump")))
inp_files.append(descriptor("celiv.inp",_("CELIV")))
inp_files.append(descriptor("math.inp",_("Math")))
inp_files.append(descriptor("tof.inp",_("ToF")))
inp_files.append(descriptor("stark.inp",_("Stark")))
inp_files.append(descriptor("pulse.inp",_("Pulse")))
inp_files.append(descriptor("pulse_voc.inp",_("Pulse Voc")))
inp_files.append(descriptor("imps.inp",_("IMPS")))
inp_files.append(descriptor("light_exp.inp",_("Light Exp")))
inp_files.append(descriptor("thermal.inp",_("Thermal")))
inp_files.append(descriptor("sun_voc.inp",_("Sun Voc")))
inp_files.append(descriptor("tpc.inp",_("TPC")))
inp_files.append(descriptor("fit.inp",_("Fit")))
inp_files.append(descriptor("lumo0.inp",_("Bands")))
inp_files.append(descriptor("epitaxy.inp",_("Density of States")))
inp_files.append(descriptor("pl0.inp",_("Luminescence")))

def inp_file_to_description(file_name):
	global inp_files
	for f in inp_files:
		if f.file==file_name:
			return f.des
	return False


