# General-purpose Photovoltaic Device Model gpvdm.com - a drift diffusion
# base/Shockley-Read-Hall model for 1st, 2nd and 3rd generation solarcells.
# The model can simulate OLEDs, Perovskite cells, and OFETs.
# 
# Copyright (C) 2008-2020 Roderick C. I. MacKenzie
# All rights reserved.
# 
# https://www.gpvdm.com
# r.c.i.mackenzie at googlemail.com
# 
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in the
#       documentation and/or other materials provided with the distribution.
#     * Neither the name of the GPVDM nor the
#       names of its contributors may be used to endorse or promote products
#       derived from this software without specific prior written permission.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL Roderick C. I. MacKenzie BE LIABLE FOR ANY
# DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.


#import sys
import os
#import shutil
#from numpy import *
#from matplotlib.figure import Figure
#from numpy import arange, sin, pi
#import gobject


articles = []
mesh_articles = []

class notes(gtk.Window):


	def callback_close(self, widget, data=None):
		self.hide()
		return True

	def callback_help(self, widget, data=None):
		cmd = 'firefox http://www.roderickmackenzie.eu/gpvdm_wiki.html'
		os.system(cmd)

	def enter_callback(self, widget, entry):
		print("edit")
		#entry_text = self.entry.get_buffer()
		entry_text=self.buf.get_text(*self.buf.get_bounds())
		a = open(os.path.join(self.sim_dir,"notes.inp"), "w")
		a.write(entry_text)
		a.close()

	def init(self,sim_dir):
		self.sim_dir=sim_dir
		self.set_size_request(500, 500)
		self.set_title("Notes")
		self.entry = gtk.TextView()
		self.buf=gtk.TextBuffer()
		self.buf.connect("changed", self.enter_callback, self.entry)
		lines=""
		if os.path.isfile(os.path.join(self.sim_dir,"notes.inp")):
			f = open(os.path.join(self.sim_dir,"notes.inp"))
			lines = f.read()
			f.close()
		self.buf.set_text(lines)
		self.entry.set_buffer(self.buf)
		self.add(self.entry)
		self.show_all()



