# General-purpose Photovoltaic Device Model gpvdm.com - a drift diffusion
# base/Shockley-Read-Hall model for 1st, 2nd and 3rd generation solarcells.
# The model can simulate OLEDs, Perovskite cells, and OFETs.
# 
# Copyright (C) 2008-2020 Roderick C. I. MacKenzie
# All rights reserved.
# 
# https://www.gpvdm.com
# r.c.i.mackenzie at googlemail.com
# 
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in the
#       documentation and/or other materials provided with the distribution.
#     * Neither the name of the GPVDM nor the
#       names of its contributors may be used to endorse or promote products
#       derived from this software without specific prior written permission.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL Roderick C. I. MacKenzie BE LIABLE FOR ANY
# DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.


from inp import inp_update_token_value
from inp import inp_get_token_value

#from global_objects import global_object_get
#from global_objects import global_isobject

import i18n
_ = i18n.language.gettext

#qt
from PyQt5.QtWidgets import QMainWindow, QTextEdit, QAction, QApplication
from PyQt5.QtGui import QIcon
from PyQt5.QtCore import QSize, Qt
from PyQt5.QtWidgets import QWidget,QSizePolicy,QVBoxLayout,QPushButton,QDialog,QFileDialog,QToolBar,QLabel,QComboBox
from PyQt5.QtCore import pyqtSignal

from code_ctrl import enable_betafeatures

class tb_item_is_imps(QWidget):

	changed = pyqtSignal()

	def call_back_mode_changed(self):
		#light_power=self.mode.currentText()
		self.changed.emit()

	def setText(self,value):
		self.mode.blockSignals(True)
		all_items  = [self.mode.itemText(i) for i in range(self.mode.count())]
		for i in range(0,len(all_items)):
		    if all_items[i] == value:
		        self.mode.setCurrentIndex(i)
		self.mode.blockSignals(False)

	def update(self):
		self.mode.blockSignals(True)
		self.mode.clear()

		self.mode.addItem("is")

		if enable_betafeatures()==True:
			self.mode.addItem("imps")

		self.mode.blockSignals(False)


	def __init__(self):
		QWidget.__init__(self)

		layout=QVBoxLayout()
		label=QLabel()
		label.setText(_("Modulation type"))
		layout.addWidget(label)

		self.mode = QComboBox(self)
		self.mode.setEditable(False)

		layout.addWidget(self.mode)

		self.setLayout(layout)

		self.update()

		self.mode.currentIndexChanged.connect(self.call_back_mode_changed)



